<script lang="ts">
  import '../app.pcss';
  import { routes, policies, successMessage, errorMessage } from '$lib/stores';
  import { ungzip } from 'pako';
  import type { Policy, Route } from '$lib';

  let fileinput: HTMLInputElement;

  function exportStore() {
    let str = JSON.stringify({
      routes: $routes,
      policies: $policies,
    });

    download('fsc-policies.rego', generateRego(str));
  }

  function download(filename: string, text: string) {
    var element = document.createElement('a');

    element.setAttribute('href', 'data:text/plain;charset=utf-8,' + encodeURIComponent(text));
    element.setAttribute('download', filename);

    element.style.display = 'none';
    document.body.appendChild(element);

    element.click();

    document.body.removeChild(element);
  }

  async function onFileSelected(e: Event) {
    const target = (e.target as HTMLInputElement);
    const file = target.files![0];
    let reader = new FileReader();
    reader.readAsText(file);
    reader.onload = () => {
      findEncodedData(reader.result as string);
    };

    // Reset the value of the input element, so the change handler will fire when the same file is re-selected
    target.value = ''; // Note: the change event only fires when the *user* changes the value, so no infinite loop is triggered, see https://developer.mozilla.org/en-US/docs/Web/API/HTMLElement/change_event
  }

  function findEncodedData(data: string) {
    const lines = data.split('\n');

    const header = '#### GENERATED CODE HEADER. ####';
    let encodedData: string = '';

    let foundHeader: boolean = false;
    for (let i: number = 0; i < lines.length; i++) {
      if (foundHeader) {
        encodedData += lines[i].substring(2);
      }

      if (lines[i] === header) {
        foundHeader = true;
      }
    }

    if (!foundHeader) {
      errorMessage.set('Kan bestand niet importeren omdat het geen importdata bevat.');
      return;
    }

    let obj: { routes: Route[]; policies: Policy[] };

    try {
      const compressData = atob(encodedData);
      const compressDataArray = Uint8Array.from(compressData, (c) => c.charCodeAt(0));
      const output = ungzip(compressDataArray);

      const validData = new TextDecoder().decode(output);

      obj = JSON.parse(validData);
    } catch (err) {
      errorMessage.set('Er ging iets fout tijdens het verwerken van de importdata');
      return;
    }

    if (!confirm('Weet je zeker dat je je huidige data wilt overschrijven?')) {
      errorMessage.set('Import geannuleerd');
      return;
    }

    policies.set(obj.policies);
    routes.set(obj.routes);

    successMessage.set('Geïmporteerde data is opgeslagen.');
  }
</script>

<header class="flex border-b border-slate-200 px-4 py-3">
  <h1 class="mr-auto text-2xl font-medium"><a href="/">FSC policy builder</a></h1>

  <button
    on:click={() => fileinput.click()}
    type="button"
    class="-my-1 mr-2 inline-flex items-center rounded-lg border border-emerald-400/50 bg-white px-3 py-2 text-sm font-medium text-emerald-700 shadow-sm hover:border-emerald-500/50 hover:bg-emerald-50 focus:outline-none focus:ring-4 focus:ring-emerald-200/50"
    ><svg xmlns="http://www.w3.org/2000/svg" class="-ml-0.5 mr-2 h-5 w-5" viewBox="0 0 24 24"
      ><g
        fill="none"
        stroke="currentColor"
        stroke-linecap="round"
        stroke-linejoin="round"
        stroke-width="2"
      >
        <path d="M14 3v4a1 1 0 0 0 1 1h4" />
        <path d="M17 21H7a2 2 0 0 1-2-2V5a2 2 0 0 1 2-2h7l5 5v11a2 2 0 0 1-2 2m-5-10v6" />
        <path d="M9.5 13.5L12 11l2.5 2.5" />
      </g></svg
    >
    Importeer
    <input
      class="hidden"
      type="file"
      accept=".rego"
      on:change={onFileSelected}
      bind:this={fileinput}
    />
  </button>

  <button
    on:click={exportStore}
    type="button"
    class="-my-1 inline-flex items-center rounded-lg border border-emerald-700 bg-emerald-600 px-3 py-2 text-sm font-medium text-white shadow-sm hover:border-emerald-800 hover:bg-emerald-700 focus:outline-none focus:ring-4 focus:ring-emerald-200"
    ><svg xmlns="http://www.w3.org/2000/svg" class="-ml-0.5 mr-2 h-5 w-5" viewBox="0 0 24 24"
      ><path
        fill="none"
        stroke="currentColor"
        stroke-linecap="round"
        stroke-linejoin="round"
        stroke-width="2"
        d="M4 17v2a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2v-2M7 11l5 5l5-5m-5-7v12"
      /></svg
    > Exporteer
  </button>
</header>

<slot />
